<template>
  <div
    class="container"
  >
    <ul>
      <li
        v-for="(info, index) of formattedValue"
        :key="`cursorinfo-${index}`"
      >
        <b>
          {{ info.key }} : {{ info.value }}
        </b>
      </li>
    </ul>
  </div>
</template>

<script>
  import { getters as g } from '../../store/constants'
  import { mapGetters } from 'vuex'

  export default {
    name: 'MetrocheckFeatureSummary',

    props: {
      value: { type: Object, required: false },
    },

    data: function () {
      return {
        timeout: null,
        internalValue: null,
        formattedValue: [],
      }
    },

    computed: {
      ...mapGetters([g.GET_POINT_BY_ID]),
    },

    watch: {
      value: function (n, o) {
        if (n === null) { /// Mouseleave
          if (this.timeout) { console.log('this.timeout exists'); return false }
          this.timeout = setTimeout(() => { this.internalValue = n; this.timeout = null }, 1000)
        } else {
          this.internalValue = n
        }
      },

      internalValue: async function (n) {
        // console.log('internalValue watcher', n)
        if (n) {
          switch (n.type) {
            case 'positions':
              // eslint-disable-next-line no-case-declarations
              const point = await this[g.GET_POINT_BY_ID](n.point_fk)
              // eslint-disable-next-line no-case-declarations
              const direction = await this[g.GET_POINT_BY_ID](n.direction_fk)
              this.formattedValue = [{
                key: '',
                value: `Vehicle ${n.distance_from_point ? 'left' : 'in station'} ${point.name_fr} direction ${direction.name_fr} on line ${n.line_fk}`,
              }]
              return
            case 'points':
              this.formattedValue = [{ key: 'Station', value: n.name_fr }]
              return
            default:
              console.debug('No info for this kind of items (%O)', n.type)
          }
        }
        this.formattedValue = []
      },
    },

    beforeDestroy () {
      clearTimeout(this.timeout)
    },

  }
</script>

<style>
  .container {
    position: absolute;
    top: 0;
    left: 0;
    z-index: 10;
    color: black;
  }
</style>
